; #########################################################################

.data
MainHDC dd 0
OpenDC dd 0

PixFrm PIXELFORMATDESCRIPTOR <>


Position1 dd 0.0,0.0,-9.0


dFloat5		dd		4.0
dColor1		dd	0.1,0.1,0.1,0.0
dColor2		dd	0.9,0.9,0.9,0.0

Float45 dq 45.0
Float3 dq 3.0
Float9 dq 9.0
Float1 dq 1.0

.code
ResizeObject PROTO :DWORD,:DWORD
DrawScene PROTO 
Init PROTO :DWORD
CreateObjects		PROTO	:DWORD,:DWORD
Surface 		PROTO    :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
; ######################################################################### 

ResizeObject PROC ParentW:DWORD,ParentH:DWORD
invoke glViewport,0,0,ParentW,ParentH
invoke glMatrixMode,GL_PROJECTION
invoke glLoadIdentity
invoke gluPerspective,DWORD PTR Float45,DWORD PTR Float45+4,DWORD PTR Float1,DWORD PTR Float1+4,DWORD PTR Float3,DWORD PTR Float3+4,DWORD PTR Float9,DWORD PTR Float9+4
invoke glMatrixMode,GL_MODELVIEW
invoke glLoadIdentity
ret
ResizeObject ENDP

; #########################################################################
CreateObjects		PROC	ParentW:DWORD,ParentH:DWORD

invoke Surface,1,4,dFloat5,ADDR dColor1,ADDR dColor2


invoke glMatrixMode,GL_PROJECTION
ret

CreateObjects		ENDP
; #########################################################################

DrawScene PROC 


invoke glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT 


put2scene 1,Position1



invoke SwapBuffers,MainHDC 
ret
DrawScene ENDP

; #########################################################################
Surface PROC ListNumber:DWORD,Parts:DWORD,DimXY:DWORD,Color1:DWORD,Color2:DWORD
LOCAL x0:DWORD,y0:DWORD,x1:DWORD,y1:DWORD,i:DWORD,j:DWORD,Hstep:DWORD
LOCAL color:DWORD;,ijStep:DWORD

.data
fZ0		dd	0.0
fZNormal	dd	-1.0
nDimXY		dd	0.0

.code
invoke   glShadeModel,GL_FLAT

fld[DimXY]

fchs
fst[nDimXY]

fld[DimXY]

fidiv [Parts]

fst[Hstep]




invoke	glNewList,ListNumber,GL_COMPILE_AND_EXECUTE 
			invoke glBegin,GL_QUADS
mov color,0

mov eax,0
mov j,eax

newcicle:
mov eax,0
mov i,eax

finit

fld[Hstep]
fimul[j]
fadd[nDimXY]

fst[y0]
fadd[Hstep]
fst[y1]


newline:
finit
fld [Hstep]
fimul[i]
fadd[nDimXY]

fst[x0]
fadd[Hstep]
fst[x1]




mov eax,color
cmp eax,1
jz newcolor
mov eax,Color1
invoke glColor4f,[eax],[eax+4],[eax+8],[eax+12]
inc color
jmp @F
newcolor:

mov eax,Color2
invoke glColor4f,[eax],[eax+4],[eax+8],[eax+12]
dec color
@@:

invoke glNormal3f,x0,y0, fZNormal
invoke glVertex3f,x0,y0, fZ0


invoke glNormal3f,x0,y0, fZNormal
invoke glVertex3f,x1,y0, fZ0


invoke glNormal3f,x0,y0, fZNormal
invoke glVertex3f,x1,y1, fZ0


invoke glNormal3f,x0,y0, fZNormal
invoke glVertex3f,x0,y1, fZ0
 inc i
mov eax,Parts
shl eax,1
cmp i,eax

jne newline  
mov eax,color
cmp eax,1
jz newcol

inc color
jmp @F
newcol:


dec color
@@:

inc j
mov eax,Parts
shl eax,1
cmp j,eax
jne newcicle                       
		invoke glEnd
invoke	glEndList
invoke glShadeModel,GL_SMOOTH
		
	ret

Surface ENDP

; #########################################################################
Init proc hWn:DWORD
LOCAL WINRect:RECT
LOCAL PixFormat:DWORD

invoke GetDC,hWn
mov MainHDC,eax
mov ax,SIZEOF PixFrm
mov PixFrm.nSize,ax
mov PixFrm.nVersion,1
mov PixFrm.dwFlags,PFD_DRAW_TO_WINDOW or PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER
mov PixFrm.dwLayerMask,PFD_MAIN_PLANE
mov PixFrm.iPixelType,PFD_TYPE_RGBA
mov PixFrm.cColorBits,8
mov PixFrm.cDepthBits,16
mov PixFrm.cAccumBits,0
mov PixFrm.cStencilBits,0
invoke ChoosePixelFormat,MainHDC,ADDR PixFrm
mov PixFormat,eax
invoke SetPixelFormat,MainHDC,PixFormat,ADDR PixFrm
or eax,eax
jz Fail
invoke wglCreateContext,MainHDC
mov OpenDC,eax
invoke wglMakeCurrent,MainHDC,OpenDC
invoke GetClientRect,hWn,ADDR WINRect

invoke	CreateObjects,WINRect.right,WINRect.bottom
invoke glEnable,GL_COLOR_MATERIAL

jmp abrt
Fail:
invoke MessageBox,hWn,SADD("OpenGL a  "),SADD("  "),MB_OK

abrt:

return 0

Init endp
; ########################################################